\entry {introduction}{1}{introduction}
\entry {context-free grammar}{13}{context-free grammar}
\entry {grammar, context-free}{13}{grammar, context-free}
\entry {BNF}{13}{BNF}
\entry {Backus-Naur form}{13}{Backus-Naur form}
\entry {symbols (abstract)}{13}{symbols (abstract)}
\entry {token}{13}{token}
\entry {syntactic grouping}{13}{syntactic grouping}
\entry {grouping, syntactic}{13}{grouping, syntactic}
\entry {start symbol}{14}{start symbol}
\entry {Hyacc grammar}{15}{Hyacc grammar}
\entry {grammar, Hyacc}{15}{grammar, Hyacc}
\entry {formal grammar}{15}{formal grammar}
\entry {semantic value}{16}{semantic value}
\entry {value, semantic}{16}{value, semantic}
\entry {semantic actions}{16}{semantic actions}
\entry {actions, semantic}{16}{actions, semantic}
\entry {Hyacc parser}{17}{Hyacc parser}
\entry {Hyacc utility}{17}{Hyacc utility}
\entry {lexical analyzer, purpose}{17}{lexical analyzer, purpose}
\entry {parser}{17}{parser}
\entry {stages in using Hyacc}{18}{stages in using Hyacc}
\entry {using Hyacc}{18}{using Hyacc}
\entry {grammar file}{18}{grammar file}
\entry {file format}{18}{file format}
\entry {format of grammar file}{18}{format of grammar file}
\entry {layout of Hyacc grammar}{18}{layout of Hyacc grammar}
\entry {simple examples}{21}{simple examples}
\entry {examples, simple}{21}{examples, simple}
\entry {reverse polish notation}{21}{reverse polish notation}
\entry {polish notation calculator}{21}{polish notation calculator}
\entry {rpcalc}{21}{\code {rpcalc}}
\entry {calculator, simple}{21}{calculator, simple}
\entry {writing a lexical analyzer}{25}{writing a lexical analyzer}
\entry {lexical analyzer, writing}{25}{lexical analyzer, writing}
\entry {controlling function}{29}{controlling function}
\entry {main function in simple example}{29}{main function in simple example}
\entry {error reporting routine}{29}{error reporting routine}
\entry {running Hyacc (introduction)}{30}{running Hyacc (introduction)}
\entry {compiling the parser}{30}{compiling the parser}
\entry {infix notation calculator}{31}{infix notation calculator}
\entry {calc}{31}{\code {calc}}
\entry {calculator, infix notation}{31}{calculator, infix notation}
\entry {error recovery, simple}{34}{error recovery, simple}
\entry {multi-function calculator}{35}{multi-function calculator}
\entry {mfcalc}{35}{\code {mfcalc}}
\entry {calculator, multi-function}{35}{calculator, multi-function}
\entry {symbol table example}{38}{symbol table example}
\entry {exercises}{40}{exercises}
\entry {HimML declarations section}{41}{HimML declarations section}
\entry {declarations, HimML}{41}{declarations, HimML}
\entry {Hyacc declarations (introduction)}{42}{Hyacc declarations (introduction)}
\entry {declarations, Hyacc (introduction)}{42}{declarations, Hyacc (introduction)}
\entry {grammar rules section}{42}{grammar rules section}
\entry {rules section for grammar}{42}{rules section for grammar}
\entry {additional HimML code section}{42}{additional HimML code section}
\entry {HimML code, section for additional}{42}{HimML code, section for additional}
\entry {nonterminal symbol}{42}{nonterminal symbol}
\entry {terminal symbol}{42}{terminal symbol}
\entry {token type}{42}{token type}
\entry {symbol}{42}{symbol}
\entry {character token}{43}{character token}
\entry {literal token}{43}{literal token}
\entry {single-character literal}{43}{single-character literal}
\entry {rule syntax}{44}{rule syntax}
\entry {grammar rule syntax}{44}{grammar rule syntax}
\entry {syntax of grammar rules}{44}{syntax of grammar rules}
\entry {{\tt\char'174}}{44}{\code {{\tt\char'174}}}
\entry {recursive rule}{45}{recursive rule}
\entry {left recursion}{45}{left recursion}
\entry {right recursion}{45}{right recursion}
\entry {mutual recursion}{46}{mutual recursion}
\entry {defining language semantics}{46}{defining language semantics}
\entry {language semantics, defining}{46}{language semantics, defining}
\entry {semantic value type}{47}{semantic value type}
\entry {value type, semantic}{47}{value type, semantic}
\entry {data types of semantic values}{47}{data types of semantic values}
\entry {default data type}{47}{default data type}
\entry {action}{47}{action}
\entry {$$}{47}{\code {$$}}
\entry {$n}{47}{\code {$\var {n}}}
\entry {Bind}{47}{\code {\code {Bind}}}
\entry {default action}{48}{default action}
\entry {action data types}{49}{action data types}
\entry {data types in actions}{49}{data types in actions}
\entry {actions in mid-rule}{49}{actions in mid-rule}
\entry {mid-rule actions}{49}{mid-rule actions}
\entry {declarations, Hyacc}{52}{declarations, Hyacc}
\entry {Hyacc declarations}{52}{Hyacc declarations}
\entry {declaring token type names}{53}{declaring token type names}
\entry {token type names, declaring}{53}{token type names, declaring}
\entry {%token}{53}{\code {%token}}
\entry {precedence declarations}{54}{precedence declarations}
\entry {declaring operator precedence}{54}{declaring operator precedence}
\entry {operator precedence, declaring}{54}{operator precedence, declaring}
\entry {declaring value types}{55}{declaring value types}
\entry {value types, declaring}{55}{value types, declaring}
\entry {%union}{55}{\code {%union}}
\entry {declaring value types, nonterminals}{55}{declaring value types, nonterminals}
\entry {value types, nonterminals, declaring}{55}{value types, nonterminals, declaring}
\entry {%type}{55}{\code {%type}}
\entry {suppressing conflict warnings}{56}{suppressing conflict warnings}
\entry {preventing warnings about conflicts}{56}{preventing warnings about conflicts}
\entry {warnings, preventing}{56}{warnings, preventing}
\entry {conflicts, suppressing warnings of}{56}{conflicts, suppressing warnings of}
\entry {%expect}{56}{\code {%expect}}
\entry {declaring the start symbol}{56}{declaring the start symbol}
\entry {start symbol, declaring}{56}{start symbol, declaring}
\entry {default start symbol}{56}{default start symbol}
\entry {%start}{56}{\code {%start}}
\entry {reentrant parser}{57}{reentrant parser}
\entry {pure parser}{57}{pure parser}
\entry {%pure{\_}parser}{57}{\code {%pure{\_}parser}}
\entry {Hyacc declaration summary}{57}{Hyacc declaration summary}
\entry {declaration summary}{57}{declaration summary}
\entry {summary, Hyacc declaration}{57}{summary, Hyacc declaration}
\entry {HimML-language interface}{59}{HimML-language interface}
\entry {interface}{59}{interface}
\entry {yyparse}{59}{\code {yyparse}}
\entry {hyacc{\_}data}{59}{\code {hyacc{\_}data}}
\entry {hyacc{\_}data}{59}{\code {hyacc{\_}data}}
\entry {yylex}{60}{\code {yylex}}
\entry {lexical analyzer}{60}{lexical analyzer}
\entry {yyvalue}{61}{\code {yyvalue}}
\entry {yylloc}{62}{\code {yylloc}}
\entry {error reporting function}{62}{error reporting function}
\entry {yyerror}{62}{\code {yyerror}}
\entry {parse error}{62}{parse error}
\entry {syntax error}{62}{syntax error}
\entry {Hyacc}{62}{\code {Hyacc}}
\entry {hyaccmsg}{62}{\code {hyaccmsg}}
\entry {summary, action features}{63}{summary, action features}
\entry {action features summary}{63}{action features summary}
\entry {hyacc{\_}value}{63}{\code {hyacc{\_}value}}
\entry {hyacc{\_}default{\_}value}{63}{\code {hyacc{\_}default{\_}value}}
\entry {hyacc{\_}error}{64}{\code {hyacc{\_}error}}
\entry {hyacc{\_}recovering}{64}{\code {hyacc{\_}recovering}}
\entry {hyacc{\_}clear{\_}in}{64}{\code {hyacc{\_}clear{\_}in}}
\entry {hyacc{\_}error{\_}ok}{64}{\code {hyacc{\_}error{\_}ok}}
\entry {{\tt\char'100}n}{64}{\code {{\tt\char'100}\var {n}}}
\entry {hyacc{\_}location}{64}{\code {hyacc{\_}location}}
\entry {hyacc{\_}max{\_}depth}{64}{\code {hyacc{\_}max{\_}depth}}
\entry {hyacc{\_}set{\_}max{\_}depth}{64}{\code {hyacc{\_}set{\_}max{\_}depth}}
\entry {Hyacc parser algorithm}{65}{Hyacc parser algorithm}
\entry {algorithm of parser}{65}{algorithm of parser}
\entry {shifting}{65}{shifting}
\entry {reduction}{65}{reduction}
\entry {parser stack}{65}{parser stack}
\entry {stack, parser}{65}{stack, parser}
\entry {look-ahead token}{66}{look-ahead token}
\entry {conflicts}{67}{conflicts}
\entry {shift/reduce conflicts}{67}{shift/reduce conflicts}
\entry {dangling else}{67}{dangling \code {else}}
\entry {else, dangling}{67}{\code {else}, dangling}
\entry {operator precedence}{68}{operator precedence}
\entry {precedence of operators}{68}{precedence of operators}
\entry {associativity}{69}{associativity}
\entry {%left}{69}{\code {%left}}
\entry {%right}{69}{\code {%right}}
\entry {%nonassoc}{69}{\code {%nonassoc}}
\entry {context-dependent precedence}{71}{context-dependent precedence}
\entry {unary operator precedence}{71}{unary operator precedence}
\entry {precedence, context-dependent}{71}{precedence, context-dependent}
\entry {precedence, unary operator}{71}{precedence, unary operator}
\entry {%prec}{71}{\code {%prec}}
\entry {finite-state machine}{72}{finite-state machine}
\entry {parser state}{72}{parser state}
\entry {state (of parser)}{72}{state (of parser)}
\entry {reduce/reduce conflict}{72}{reduce/reduce conflict}
\entry {conflicts, reduce/reduce}{72}{conflicts, reduce/reduce}
\entry {LR(1)}{75}{LR(1)}
\entry {LALR(1)}{75}{LALR(1)}
\entry {stack overflow}{76}{stack overflow}
\entry {parser stack overflow}{76}{parser stack overflow}
\entry {overflow of parser stack}{76}{overflow of parser stack}
\entry {hyacc{\_}set{\_}max{\_}depth}{76}{\code {hyacc{\_}set{\_}max{\_}depth}}
\entry {default stack limit}{77}{default stack limit}
\entry {error recovery}{79}{error recovery}
\entry {recovery from errors}{79}{recovery from errors}
\entry {error}{79}{\code {error}}
\entry {hyacc{\_}error{\_}ok}{80}{\code {hyacc{\_}error{\_}ok}}
\entry {hyacc{\_}clear{\_}in}{80}{\code {hyacc{\_}clear{\_}in}}
\entry {hyacc{\_}recovering}{81}{\code {hyacc{\_}recovering}}
\entry {lexical tie-in}{84}{lexical tie-in}
\entry {debugging}{87}{debugging}
\entry {tracing the parser}{87}{tracing the parser}
\entry {hyacc{\_}set{\_}debug}{87}{\code {hyacc{\_}set{\_}debug}}
\entry {invoking Hyacc}{89}{invoking Hyacc}
\entry {Hyacc invocation}{89}{Hyacc invocation}
\entry {options for invoking Hyacc}{89}{options for invoking Hyacc}
\entry {invoking Hyacc under VMS}{91}{invoking Hyacc under VMS}
\entry {VMS}{91}{VMS}
\entry {Hyacc symbols, table of}{93}{Hyacc symbols, table of}
\entry {symbols in Hyacc, table of}{93}{symbols in Hyacc, table of}
\entry {glossary}{97}{glossary}
